package com.xxxxxxx.drvpp.biz.web.xyz.business;

import java.util.Map;

import org.springframework.ui.Model;

import com.xxxxxxx.drvpp.fw.common.log.Logger;
import com.xxxxxxx.drvpp.fw.common.log.LoggerFactory;
import com.xxxxxxx.drvpp.fw.common.log.LoggerFactoryBuilder;
import com.xxxxxxx.drvpp.fw.web.util.Business;
import com.xxxxxxx.drvpp.fw.web.util.SessionInfo;
import com.xxxxxxx.drvpp.fw.web.util.WebParameter;

public class BusinessC implements Business<WebParameter> {
	public int doExecute(WebParameter parameter) {
    	LoggerFactoryBuilder loggerFactoryBuilder = LoggerFactoryBuilder.getInstance();
    	LoggerFactory loggerFactory = loggerFactoryBuilder.getLoggerFactory();
    	Logger log = loggerFactory.getLogger(this.getClass());
		log.info(this.getClass().getSimpleName());

		// リクエストパラメータ取得
		Map<String, String> param = parameter.getRequestParameter();
		String value = param.get("foo");
		System.out.println("foo=" + value);
		
		// セッションから値を取得(スコープは、セッション)
		SessionInfo sessionInfo = parameter.getSessionInfo();
		Map<String, Object> map = sessionInfo.get(SessionInfo.SCOPE_SESSION);
		String sessionValue = (String)map.get("foo");

		// セッションの値を更新
		if (sessionValue == null){
			sessionValue = "";
		}
		sessionValue += value;
		map.put("foo", sessionValue);

		// JSPから参照するためのモデルに格納
		Model model = parameter.getModel();
		model.addAttribute("foo", sessionValue);
		
		// 遷移先画面の設定
		parameter.setViewName("/controller");

		return 0;
	}
}
